<template>
  <div>
    <AlertBox ref="alertBox" />
    <v-dialog v-model="dialog" max-width="600px" persistent>
      <v-card>
        <v-card-title>
          <span class="headline">แก้ไขข้อมูลผู้ใช้</span>
        </v-card-title>
        <v-card-text>
          <v-row>
            <v-col cols="6" id="firstname">
              <v-text-field v-model="formUser.firstname"
                            @keyup.enter="updateProfiles"
                            :error-messages="firstNameErrors"
                            label="ชื่อ"
                            required
                            clearable />
            </v-col>
            <v-col cols="6" id="lastname">
              <v-text-field v-model="formUser.lastname"
                            @keyup.enter="updateProfiles"
                            :error-messages="lastNameErrors"
                            label="นามสกุล"
                            required
                            clearable />
            </v-col>
            <v-col cols="12" id="age">
              <v-text-field v-model="formUser.age"
                            @keyup.enter="updateProfiles"
                            :error-messages="ageErrors"
                            oninput="this.value=this.value.replace(/^[0a-zA-Z][0-9a-zA-Z]*$/g,'');"
                            label="อายุ"
                            required
                            clearable />
            </v-col>
            <v-col cols="12" id="tel">
              <v-text-field v-model="formUser.tel"
                            @keyup.enter="updateProfiles"
                            oninput="this.value=this.value.replace(/[^0-9]/g,'');"
                            :error-messages="telErrors"
                            label="เบอร์โทรศัพท์"
                            required
                            clearable />
            </v-col>
            <v-col cols="12">
              <v-textarea
                id="address"
                outlined
                name="input-7-4"
                label="ที่อยู่"
                :error-messages="addressErrors"
                required
                v-model="formUser.address" />
            </v-col>
          </v-row>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red darken-1" text @click="close">ยกเลิก</v-btn>
          <v-btn color="blue darken-1" text :loading="loadingBeforeUpdateProfiles" @click="updateProfiles">บันทึกข้อมูล</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
  import { validationMixin } from "vuelidate";
  import { required, minLength, between } from "vuelidate/lib/validators";
  import AlertBox from '~/components/general/alert-box/AlertBox'

  export default {
    name: "editProfilePopup",
    components: {
      AlertBox
    },
    mixins: [validationMixin],
    validations: {
      formUser: {
        firstname: { required },
        lastname: { required },
        age: { required, between: between(20, 100) },
        tel: { required, minLength: minLength(10) },
        address: { required }
      }
    },
    computed: {
      firstNameErrors() {
        const errors = [];
        if (!this.$v.formUser.firstname.$dirty) return errors;
        !this.$v.formUser.firstname.required && errors.push("กรุณากรอกชื่อ");
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.formUser.lastname.$dirty) return errors;
        !this.$v.formUser.lastname.required && errors.push("กรุณากรอกนามสกุล");
        return errors;
      },
      ageErrors() {
        const errors = [];
        if (!this.$v.formUser.age.$dirty) return errors;
        !this.$v.formUser.age.between && errors.push('กรุณากรอกอายุไม่เกิน 20-100 ปี')
        !this.$v.formUser.age.required && errors.push("กรุณากรอกอายุ");
        return errors;
      },
      telErrors() {
        const errors = [];
        if (!this.$v.formUser.tel.$dirty) return errors;
        !this.$v.formUser.tel.minLength && errors.push('กรุณากรอกเบอร์โทรศัพท์อย่างน้อย 10 ตัวอักษร')
        !this.$v.formUser.tel.required && errors.push("กรุณากรอกเบอร์โทรศัพท์");
        return errors;
      },
      addressErrors() {
        const errors = [];
        if (!this.$v.formUser.address.$dirty) return errors;
        !this.$v.formUser.address.required && errors.push("กรุณากรอกที่อยู่");
        return errors;
      }
    },
    data() {
      return {
        dialog: false,
        formUser: {},
        loadingBeforeUpdateProfiles: false,
      }
    },
    methods: {
      showAlert: function (value) {
        const vm = this
        const alert = {
          'mainTitle': value.title,
          'subTitle': value.text,
          'type': value.type,
          'time': value.time,
          'autoClose': value.autoClose,
          'show': value.show
        }
        vm.$refs.alertBox.showBox(alert)
      },
      getProfiles(value) {
        const vm = this
        vm.formUser = value
      },
      close() {
        const vm = this
        vm.$v.$reset()
        vm.dialog = false
        vm.formUser = {}
      },
      updateProfiles() {
        const vm = this
        vm.$v.$touch()
        if (!vm.firstNameErrors[0] && !vm.lastNameErrors[0] &&
          !vm.ageErrors[0] && !vm.telErrors[0] && !vm.addressErrors[0]) {
          vm.loadingBeforeUpdateProfiles = true
          delete vm.formUser.role
          vm.$axios.$patch('/user/update-user-profile', vm.formUser)
            .then((res) => {
              vm.$emit('updateProfile')
              vm.showAlert({ title: 'สำเร็จ', text: res.data.massage, type: 'success', time: 3, autoClose: true, show: true })
              setTimeout(() => {
                vm.$v.$reset()
                vm.dialog = false
                vm.formUser = {}
              }, 3000)
            })
            .catch((e) => {
              if (e.response) {
                vm.showAlert({title: 'ผิดพลาด!', text: e.response.data.messages, type: 'error', time: 5, autoClose: true, show: true})
              }
            })
            .finally(() => {
              vm.loadingBeforeUpdateProfiles = false
            })
        }
      }
    }
  }
</script>

<style scoped>

</style>
